// RunnerHead.as

#include "BJ_Blowjob.as";

const s32 NUM_HEADFRAMES = 4;
const s32 NUM_UNIQUEHEADS = 30;
const int FRAMES_WIDTH = 8 * NUM_HEADFRAMES;

int getHeadFrame(CBlob@ blob, int headIndex)
{
	return (((headIndex-NUM_UNIQUEHEADS/2) * 2) + (blob.getSexNum() == 0 ? 0 : 1)) * NUM_HEADFRAMES;
}

void checkName(CPlayer@ player, CBlob@ blob)
{
	blob.set_string("texName", "Entities/Characters/Sprites/Heads.png");
	//print(":::: texName         : " + texName);
	//print(":::: player.name     : " + player.getUsername());
	//print("-----------------------");
	for (uint n = 0; n < blown.length; n++) {
		//print(":::: blown.name      : " + blown[n]);
		if (blob.getPlayer() !is null) {
			if (player.getUsername() == blown[n]) {
				blob.set_string("playerName", blown[n]);
				blob.set_string("texName", "../Mods/Blowjob/Heads/"+blown[n]+".png");
				//print(":::: blown.string    : " + blob.get_string("texName"));
				break;
			}
		}
	}
}

bool hasBlowjob(CPlayer@ player, CBlob@ blob)
{
	if (blob.getPlayer() is null) {
		return false;
	}
	else if (player.getUsername() == blob.get_string("playerName")) {
		return true;
	}
	else {
		return false;
	}
}

CSpriteLayer@ LoadHead(CSprite@ this, u8 headIndex)
{
	this.RemoveSpriteLayer("head");
	CBlob@ blob = this.getBlob();
	CPlayer@ player = blob.getPlayer();
	checkName(player, blob);
	CSpriteLayer@ head = this.addSpriteLayer( "head", blob.get_string("texName"), 16, 16, blob.getTeamNum(), blob.getSkinNum());
	if (hasBlowjob(player, blob)) {
		blob.set_s32("headFrame", 0);
		//ToDo - add optional special effects
		//ToDo - add optional sound effects
	}
	else {
		if (headIndex == 255 || headIndex == NUM_UNIQUEHEADS) {
			if (blob.getConfig() == "builder") {
				headIndex = NUM_UNIQUEHEADS;
			}
			else if (blob.getConfig() == "knight") {
				headIndex = NUM_UNIQUEHEADS+1;
			}
			else if (blob.getConfig() == "archer") {
				headIndex = NUM_UNIQUEHEADS+2;
			}
			else if (blob.getConfig() == "migrant") {
				headIndex = 69+XORRandom(2);
			}
			else {
				headIndex = NUM_UNIQUEHEADS;
			}
		}
		blob.set_s32("headFrame", getHeadFrame(blob, headIndex));
		if (headIndex < NUM_UNIQUEHEADS) {
			blob.set_s32("headFrame", headIndex * NUM_HEADFRAMES);
		}
	}
	blob.set_s32("head index", blob.get_s32("headFrame"));
	//print(":::: headFrame : " + blob.get_s32("headFrame"));
	if (head !is null) {
		Animation@ anim = head.addAnimation( "default", 0, false );
		anim.AddFrame(blob.get_s32("headFrame"));
		anim.AddFrame(blob.get_s32("headFrame") + 1);
		anim.AddFrame(blob.get_s32("headFrame") + 2);
		head.SetAnimation(anim);
		head.SetFacingLeft(blob.isFacingLeft());
	}
	return head;
}

void onGib(CSprite@ this)
{
	if (g_kidssafe) {
		return;
	}
	CBlob@ blob = this.getBlob();
	CPlayer@ player = blob.getPlayer();
	if (blob !is null) {
		int frame = blob.get_s32("head index");
		int frameX = (frame % FRAMES_WIDTH) + 2;
		int frameY = frame / FRAMES_WIDTH;
		//print(":::: frame         = " + frame);
		//print(":::: frameLocation = " + frameX + ", " + frameY);
		Vec2f pos = blob.getPosition();
		Vec2f vel = blob.getVelocity();
		f32 hp = Maths::Min(Maths::Abs(blob.getHealth()),2.0f) + 1.5;
		makeGibParticle(blob.get_string("texName"), pos, vel + getRandomVelocity( 90, hp , 30 ), frameX, frameY, Vec2f (16,16), 2.0f, 20, "/BodyGibFall", blob.getTeamNum());
	}
}

void onTick(CSprite@ this)
{
	CBlob@ blob = this.getBlob();
	ScriptData@ script = this.getCurrentScript();
	if (script is null) {
		return;
	}
	if(blob.getShape().isStatic()) {
		script.tickFrequency = 60;
	}
	else {
		script.tickFrequency = 1;
	}
	CSpriteLayer@ head = this.getSpriteLayer("head");
	if (head is null && (blob.getPlayer() !is null || (blob.getBrain() !is null && blob.getBrain().isActive()) || blob.getTickSinceCreated() > 3)) {
		@head = LoadHead(this, blob.getHeadNum());
	}
	if (head !is null) {
		PixelOffset @po = getDriver().getPixelOffset(this.getFilename(), this.getFrame());
		if (po !is null) {
			if (po.level == 0) {
				head.SetVisible(false);
			}
			else {
				head.SetVisible(this.isVisible());
				head.SetRelativeZ(po.level * 0.25f);
			}
			Vec2f headoffset(this.getFrameWidth()/2, -this.getFrameHeight()/2);
			headoffset += this.getOffset();
			headoffset += Vec2f(-po.x, po.y);
			headoffset += Vec2f(0, -2);
			head.SetOffset(headoffset);
			if (blob.hasTag("dead") || blob.hasTag("dead head")) {
				head.animation.frame = 2;
			}
			else if (blob.hasTag("attack head")) {
				head.animation.frame = 1;
			}
			else {
				head.animation.frame = 0;
			}
		}
		else {
			head.SetVisible(false);
		}
	}
}